#![allow(dead_code)]

use hidapi::HidApi;

//use donten::hid;

struct Report {
    device:usize,
    interface:usize,
    data:Vec<u8>,
}

struct Usage {
    usage_page:u16,
    usage:u16,

    offset:usize,
    bit_length:usize,

    minimum:u32,
    maximum:u32,
}

struct ReportDescriptor {
    id:usize,
    usages:Vec<Usage>,
    data:Vec<u8>,
}

struct DeviceInterface {
    reports:Vec<ReportDescriptor>,
}

struct Device {
    product:String,
    manufacturer:String,
    serial:String,

    interfaces:Vec<DeviceInterface>,
}

fn main()
{
    let (_tx, _rx) = crossbeam::channel::bounded::<Vec<u8>>(100);

    if let Ok(hid) = HidApi::new() {

        let mut devices = Vec::<Device>::new();

        println!("[Device List]");
        for device_info in hid.device_list() {

            let product = if let Some(s) = device_info.product_string() { s } else { "" }.to_string();
            let manufacturer = if let Some(s) = device_info.manufacturer_string() { s } else { "" }.to_string();
            let serial = if let Some(s) = device_info.serial_number() { s } else { "" }.to_string();

            let mut index = 0;
            while index < devices.len() {
                if devices[index].product == product
                && devices[index].manufacturer == manufacturer
                && devices[index].serial == serial
                {
                    break;
                }
                index += 1;
            }

            if index == devices.len() {
                // Insert new device

                let device = Device {
                    product,
                    manufacturer,
                    serial,

                    interfaces:Vec::new(),
                };

                println!(" - {} ({})",
                    device.product,
                    device.manufacturer,
                );

                devices.push(device);
            }
            
            /*

            // Add usage to device.
            let mut desc_bytes = [0u8; hidapi::MAX_REPORT_DESCRIPTOR_SIZE];

            if let Ok(hwd) = device_info.open_device(&hid) {
                if let Ok(desc_size) = hwd.get_report_descriptor(&mut desc_bytes) {

                    if let Ok(descriptor) = hid::ReportDescriptor::parse(&desc_bytes[0..desc_size]) {
                        let interface = DeviceInterface {
                            reports:Vec::new(),
                        };
                        let mut buffer_length = 0;

                        // Push interface to device.
                        let interface_index = devices[index].interfaces.len();
                        devices[index].interfaces.push(interface);
        
                        // Listen for input reports from device.
                        let _ttx = tx.clone();
                        std::thread::spawn(move || {
                            let _device_index = index;
                            let _interface_index = interface_index;
                            let buffer_length = buffer_length;

                            let hwd = hwd;

                            let mut buffer = vec![0u8; buffer_length];
                            while let Ok(_size) = hwd.read(&mut buffer) {

                            }
                        });
                    }
                }
            }

            */
        }

        // Process input reports.
        /*while let Ok(_msg) = rx.recv() {

        }*/
    } else {
        println!("failed to init hidapi.");
    }
}
